-----------------------------------------------------------------------------------------------
-- Author: Frosthaven
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------

require "Apollo"
require "GameLib"
require "Window"
 
-- DEFINITION ---------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
local FMAR = {
	debug       = false,
}

-- INITIALIZATION -----------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
function FMAR:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self
    return o
end

function FMAR:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		--dependencies
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end

-- EVENTS -------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
function FMAR:OnLoad()
	--remove ads will run after the ui runs
	Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "DelayInit", self)

	-- setup timer -----------------------------------------------------
	--------------------------------------------------------------------
	self.timer = ApolloTimer.Create(3, false, "OnTimer", self)
end

-- METHODS ------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
function FMAR:OnTimer()
	self:RemoveSignatureStatus()
	self:RemoveStoreGlow()
end

function FMAR:DelayInit()
	self.timer:Start()
end

function FMAR:RemoveStoreGlow()
	local addon = Apollo.GetAddon("InterfaceMenuList")
	if not addon or type(addon.wndMain) == "nil" then return end

	local storebutton = addon.wndMain:FindChild("OpenMarketplaceBtn")
	if storebutton then
		storebutton:FindChild("MTXBtn_Runner"):SetSprite("ClientSprites:Clear")
	end
end

function FMAR:RemoveSignatureStatus()
	local addon = Apollo.GetAddon("XPBar")
	if not addon or type(addon.wndMain) == "nil" then return end

	local xpcontainer = addon.wndMain:FindChild("BaseBarCornerForm")

	if xpcontainer and xpcontainer:FindChild("SignatureIndicator"):IsVisible() then
		local gapless     = 55
		local xpbar       = xpcontainer:FindChild("XPBarContainer")
		local eldergems   = xpcontainer:FindChild("ElderGems")
		local xpbutton    = xpcontainer:FindChild("XPButton")
		local pathbar     = xpcontainer:FindChild("PathBarContainer")
		local pathbutton  = xpcontainer:FindChild("PathButton")
		local pathicon    = xpcontainer:FindChild("PathIcon")
		local indicator   = xpcontainer:FindChild("SignatureIndicator")
		indicator:Show(false, true)

		nLeft, nTop, nRight, nBottom = xpbar:GetAnchorOffsets()
		xpbar:SetAnchorOffsets(nLeft + gapless, nTop, nRight + gapless, nBottom)

		nLeft, nTop, nRight, nBottom = eldergems:GetAnchorOffsets()
		eldergems:SetAnchorOffsets(nLeft + gapless, nTop, nRight + gapless, nBottom)

		nLeft, nTop, nRight, nBottom = xpbutton:GetAnchorOffsets()
		xpbutton:SetAnchorOffsets(nLeft + gapless, nTop, nRight + gapless, nBottom)

		nLeft, nTop, nRight, nBottom = pathbar:GetAnchorOffsets()
		pathbar:SetAnchorOffsets(nLeft - gapless, nTop, nRight - gapless, nBottom)

		nLeft, nTop, nRight, nBottom = pathbutton:GetAnchorOffsets()
		pathbutton:SetAnchorOffsets(nLeft - gapless, nTop, nRight - gapless, nBottom)

		nLeft, nTop, nRight, nBottom = pathicon:GetAnchorOffsets()
		pathicon:SetAnchorOffsets(nLeft - gapless, nTop, nRight - gapless, nBottom)
	end
end

-- CREATE INSTANCE ----------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
local FMARInst = FMAR:new()
FMARInst:Init()